;;
;; Ploting 2D results
;;
;; $Id$
;;
; choice of device
;plot_choice='cps'
;plot_choice='ps'
plot_choice='x'
;
iwx=1 & jwy=2

a=findgen(17) * (!pi * 2 / 16.)
usersym, 0.5*cos(a), 0.5*sin(a),/fill

!p.charsize=1.2
!p.charthick=1.2

mmmin=1
mmmax=11

xrange=[-0.3,0.3] & yrange=[-0.15,0.15]


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
case plot_choice of
'x' : begin
window,4,xs=600,ys=600,xpos=400,retain=2
;window,5,xs=1200,ys=1200,xpos=400
end
'ps' : begin
set_plot,'ps'
device,/portrait
device,/inches,xsize=7,ysize=7.5,yoffset=1,font_size=8
;!p.font=0 & device,/times,/italic
end
'cps' : begin
set_plot,'ps'
;device,/color,bits_per_pix=5
device,/color,/inches,xsize=6.5,ysize=7.5,yoffset=1,font_size=8
;device,/landscape
;device,xoffset=0.5,yoffset=24.5,xsize=19*6.5/7.*0.8,ysize=19*0.8
;!p.font=0 & device,/times,/italic
end
endcase

iw=iwx*jwy
dx0=1./iwx
dy0=1./jwy

!p.multi=[0,iwx,jwy]
!x.margin=[8.,6.]
!y.margin=[4.,4.]

mm1=1
mm2=11

i=0
itemp=0
;
; If plot_choice='ps' or 'cps', following line should comment out.
;
; CASE !D.Name OF
; 'X': device,decompose=0
; ELSE:
; ENDCASE
;
; If you want to use different color palette, you should change number of loadct; or select ldmyct (original color palette)
;
;   loadct,1
;   TVLCT, r, g, b, /Get
;   TVLCT, Reverse(r), Reverse(g), Reverse(b);\

  If(plot_choice eq 'x') then begin
    device,decompose=0
  endif
;    ldmyct,clr_index=clr,white=white,black=black
;

;
; (1) magnetic energy density
;

  bb=b1^2+b2^2+b3^2
  bb1=smooth(bb,1)
  
  data1=bb*10.0^7
  
clr=[10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,190]
;levels1=[0.0,2.5,3.0,3.5,4.0,5.0,5.5,6.0,6.5,7.5,8.5,9.5,10.5,11.0,12.0]
levels1=[0.0,1.0,2.0,3.0,4.0,4.5,5.0,5.5,6.0,6.5,7.0,8.0,9.0,10.0,15.0]
;levels1=[0.0,1.0,2.0,3.0,4.0,5.0,6.0,7.0,8.0,9.0,10.0,12.0,13.0,14.0,15.0]
  
  data2=-pom
  
    fccnve $
     ,nofilled=0,nocontour=0,novector=1 $
     ,xrange=xrange,yrange=yrange $
     ,data1(*,*,mm1) $
     ,levels1=levels1,clr_index=clr, c_thick=1.5 $
     ,data2(*,*,mm1) $
     ,levels2=min(data2(*,*,mm1))+(max(data2(*,*,mm1))-min(data2(*,*,mm1)))*(findgen(8)/8)^2$
;     ,levels2=[0.0] $
     ,v1(*,*,mm1),v2(*,*,mm1) $
     ,scale=0.1,index_size=1.0, xarrow=0.65, limit=0.1,/sample $
     ,xplot=-0.3+0.01*findgen(100),yplot=-0.15+0.01*findgen(100) $
     ,xcord=xar,ycord=yar,xtitle='!8x',ytitle='!8y' $
     ,v_color=white $ 
    ,c_colors=black, Index_color=white, Axis_color=white 
;
i=0
	x0=dx0*(i mod iwx)
	y0=dy0*((i-(i mod iwx))/iwx)

   xyouts,/normal,x0+dx0*0.08,1.-(y0+dy0*0.20-0.05),'!8(a) '
   
   xyouts,/normal,x0+dx0*0.25,1.-(y0+dy0*0.20-0.05),'!8time = '
   xyouts,/normal,x0+dx0*0.58,1.-(y0+dy0*0.20-0.05), $
     strmid(strcompress(string(ctime(mm1)),/remove_all),0,4)

    printf,-1,mm2,format='(i3,$)'
    fccnve $
     ,nofilled=0,nocontour=0,novector=1 $
     ,xrange=xrange,yrange=yrange $
     ,data1(*,*,mm2) $
     ,levels1=levels1,clr_index=clr, c_thick=1.5 $
     ,data2(*,*,mm2) $
     ,levels2=min(data2(*,*,mm2))+(max(data2(*,*,mm2))-min(data2(*,*,mm2)))*(findgen(7)/7)^2$
;     ,levels2=min(data2(*,*,mm2))+(max(data2(*,*,mm2))-min(data2(*,*,mm2)))*(findgen(20)/20)$
     ,v1(*,*,mm2),v2(*,*,mm2) $
     ,scale=2.8,index_size=1.0, xarrow=0.65, limit=0.1,/sample $
     ,xplot=-0.+0.65*findgen(100),yplot=-0.+0.65*findgen(100) $
     ,xcord=xar,ycord=yar, xtitle='!8x',ytitle='!8y' $
     ,v_color=white $
     ,c_colors=white,Index_color=white, Axis_color=white 

i=1
	x0=dx0*(i mod iwx)
	y0=dy0*((i-(i mod iwx))/iwx)

   xyouts,/normal,x0+dx0*0.08,1.-(y0+dy0*0.20-0.05),'!8(b) '
   xyouts,/normal,x0+dx0*0.25,1.-(y0+dy0*0.20-0.05),'!8time = '
   xyouts,/normal,x0+dx0*0.58,1.-(y0+dy0*0.20-0.05),$
     strmid(strcompress(string(ctime(mm2)),/remove_all),0,4)

   
    barposition=[0.97,0.58,0.99,0.88]
    b_min=0.0 & b_max=12.0

  color_bar2,/noerase,levels1 $
    ,clr $
   ,position=barposition,b_min=b_min,b_max=b_max
   
; back to default

!x.range=[0.,0.]
!y.range=[0.,0.]
!x.margin=[10.,3.]
!y.margin=[4.,2.]
!p.charsize=1.
!p.thick=1.
!p.multi=0

if (plot_choice ne 'x') then begin
   device,color=0
   device,/close
   !p.font=-1
;   set_plot,'x'
endif

;delvar,data1,data2
end

